#include "player.h"
#include "input.h"
#include "TZR.h"
#include "px.h"
#include "cfg.h"
#include "mat.h"

enum {
	PLAYER_WIDTH = 32,
	PLAYER_HEIGHT = 32,
};

extern const PxSpr spr_player;

Player
player_init(void)
{
	return (Player){
		.x=PLAYER_WIDTH,
		.y=PX_HEIGHT / 2.0,
		.dir=2,
	};
}

void
player_update(Player *this)
{
	extern int background;

	this->frame_x += 2;
	this->frame_y += 3;
	this->frame_x %= spr_player.w - PLAYER_WIDTH;
	this->frame_y %= spr_player.h - PLAYER_HEIGHT;
	this->y = PX_HEIGHT / 2.0 + sin(this->tick * 2 / TARGET_FPS) * PLAYER_HEIGHT * 3;
	this->tick += 1;

	if (input_pressed("move"))
		TZR_PlayMusic("res/rise.wav", INT_MAX);
	if (input_released("move") && !input_down("move"))
		TZR_PlayMusic("res/ost.wav", INT_MAX);
	this->x += input_down("move") * this->dir;
	if ((this->dir > 0 && this->x > PX_WIDTH - PLAYER_WIDTH) ||
	    (this->dir < 0 && this->x < PLAYER_WIDTH)) {
		this->dir *= -1;
		background += 1;
	}
}

void
player_draw(Player *this)
{
	const int dx = round(this->x) - PLAYER_WIDTH / 2.0 - 2 + rand() % 5;
	const int dy = round(this->y) - PLAYER_HEIGHT / 2.0 - 2 + rand() % 5;

	pxSpr(&spr_player, dx, dy, this->frame_x, this->frame_y, PLAYER_WIDTH, PLAYER_HEIGHT);
}
